// C Source File
// Created 1/1/2006; 10:05:58 AM
// Tron v1.00 - By Tyler Cassidy
// (C) Copyright 2006 Tyler Cassidy. All Rights Reserved.
// Email: altadogsledder89@yahoo.ca
//        tyler@tylerc.org
// Website: none yet
// ** Note: I will not be responsible for anything that this game game does to your calculator!

// Definitions
// #define MIN_AMS 200 // Only Enable this if you are not using TIGCC IDE

// Header Files
#include <tigcclib.h> // All TIGCC Header Files
#include "extgraph.h" // ExtGraph Library v2.00 B5
#include "tron.h" // Tron Header File
#include "ai.h" // Artificial Intellegence Header File
#include "engine.h" // Game Engine Header File

// Initial AI Distance Call/Direction - void AI_Initialize(void)
void AI_Initialize(void) {
	// Lets find out which direction
	randomize(); // Place Random Seed
	short go_aidir = random(2); // Get a value
	if (go_aidir == 1) go_aidir = 3; // Go Left instead of Right
	gameplay.their_dir = go_aidir; // Set Direction
	
	// Now lets setup how far, at first (cut offs, etc.);
	randomize();
	gameplay.comp_dist = random(75) + 6; // Anywhere between 5 and 80 :)
	// End of Initial AI Distance Call/Direction
}

// AI Recalculation Function - void AI_RecalculateDirDist(void)
void AI_RecalculateDirDist(void) {
  // Lets Now Change Direction
	AI_ChangeDir();
	
	// Lets update the New Direction
	gameplay.comp_last_hum_dir = gameplay.your_dir; // Direction Updated
	
	// End of AI Recalculation Function
}

// AI Change Direction Function - void AI_ChangeDir(void)
void AI_ChangeDir(void) {
	short veto_dir, dist_to_line[4], i;
	veto_dir = 0;
	
	// Add 100% Veto Direction
	if (gameplay.their_dir == 0) veto_dir = 2; // Do not want to go down
	if (gameplay.their_dir == 1) veto_dir = 3; // Do not want to go left
	if (gameplay.their_dir == 2) veto_dir = 0; // Do not want to go up
	if (gameplay.their_dir == 3) veto_dir = 1; // Do not want to go right
	
	/// Lets Find the distances
  // Upwards
  for(i=gameplay.their_y; i>=0; i--) {
  	if (GetPix(gameplay.their_x, i) == TRUE) dist_to_line[0] = gameplay.their_y - i - 1; // Calculate
  }
  
  // Right
  for(i=gameplay.their_x; i<=LCD_WIDTH - 1; i++) {
  	if (GetPix(i, gameplay.their_y) == TRUE) dist_to_line[1] = i - gameplay.their_x - 1; // Calculate
  }
  
  // Down
  for(i=gameplay.their_y; i<=LCD_HEIGHT - 1; i++) {
  	if (GetPix(gameplay.their_x, i) == TRUE) dist_to_line[2] =  i - gameplay.their_y - 1; // Calculate
  }
  
  // Left
  for(i=gameplay.their_x; i>=0; i--) {
  	if (GetPix(i, gameplay.their_y) == TRUE) dist_to_line[3] = gameplay.their_x - i - 1; // Calculate
  }
  
  // Make a Decision now
  while(1) {
  	randomize(); // Plant Random Seed
  	i = random(4); // Select any Direction
  	
  	// Lets make sure that the direction is not the veto one....
  	if (i != veto_dir) {
  		// Now lets make sure the distance is atleast 1 pixel long
  		if (dist_to_line[i] >= 1) {
        // Lets set the information!
  			gameplay.their_dir = i; // Direction Set
  			randomize(); // Plant new Random Seed
  			gameplay.comp_dist = random(dist_to_line[i]); // Distance Set
  		 break; // Lets get out of here
  		}
  	}
  }
	
	// End of AI Change Direction Function
}